<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_JPCodeSynonym ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_JPCodeSynonym extends AbstractStructArrayBase
{
    /**
     * The JPCodeSynonym
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_JPCodeSynonym[]
     */
    public $JPCodeSynonym;
    /**
     * Constructor method for ArrayOfJP_JPCodeSynonym
     * @uses ArrayOfJP_JPCodeSynonym::setJPCodeSynonym()
     * @param \StructType\JP_JPCodeSynonym[] $jPCodeSynonym
     */
    public function __construct(array $jPCodeSynonym = array())
    {
        $this
            ->setJPCodeSynonym($jPCodeSynonym);
    }
    /**
     * Get JPCodeSynonym value
     * @return \StructType\JP_JPCodeSynonym[]|null
     */
    public function getJPCodeSynonym()
    {
        return $this->JPCodeSynonym;
    }
    /**
     * This method is responsible for validating the values passed to the setJPCodeSynonym method
     * This method is willingly generated in order to preserve the one-line inline validation within the setJPCodeSynonym method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateJPCodeSynonymForArrayConstraintsFromSetJPCodeSynonym(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_JPCodeSynonymJPCodeSynonymItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_JPCodeSynonymJPCodeSynonymItem instanceof \StructType\JP_JPCodeSynonym) {
                $invalidValues[] = is_object($arrayOfJP_JPCodeSynonymJPCodeSynonymItem) ? get_class($arrayOfJP_JPCodeSynonymJPCodeSynonymItem) : sprintf('%s(%s)', gettype($arrayOfJP_JPCodeSynonymJPCodeSynonymItem), var_export($arrayOfJP_JPCodeSynonymJPCodeSynonymItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The JPCodeSynonym property can only contain items of type \StructType\JP_JPCodeSynonym, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set JPCodeSynonym value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_JPCodeSynonym[] $jPCodeSynonym
     * @return \ArrayType\ArrayOfJP_JPCodeSynonym
     */
    public function setJPCodeSynonym(array $jPCodeSynonym = array())
    {
        // validation for constraint: array
        if ('' !== ($jPCodeSynonymArrayErrorMessage = self::validateJPCodeSynonymForArrayConstraintsFromSetJPCodeSynonym($jPCodeSynonym))) {
            throw new \InvalidArgumentException($jPCodeSynonymArrayErrorMessage, __LINE__);
        }
        $this->JPCodeSynonym = $jPCodeSynonym;
        return $this;
    }
    /**
     * Add item to JPCodeSynonym value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_JPCodeSynonym $item
     * @return \ArrayType\ArrayOfJP_JPCodeSynonym
     */
    public function addToJPCodeSynonym(\StructType\JP_JPCodeSynonym $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_JPCodeSynonym) {
            throw new \InvalidArgumentException(sprintf('The JPCodeSynonym property can only contain items of type \StructType\JP_JPCodeSynonym, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->JPCodeSynonym[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_JPCodeSynonym|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_JPCodeSynonym|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_JPCodeSynonym|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_JPCodeSynonym|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_JPCodeSynonym|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string JPCodeSynonym
     */
    public function getAttributeName()
    {
        return 'JPCodeSynonym';
    }
}
